VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Frequency Counter"
   ClientHeight    =   2370
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3540
   Icon            =   "c1mhz.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2370
   ScaleWidth      =   3540
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text2 
      Alignment       =   1  'Right Justify
      BackColor       =   &H80000006&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   24
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000FF00&
      Height          =   660
      Left            =   120
      TabIndex        =   7
      Text            =   "000000"
      Top             =   960
      Width           =   1850
   End
   Begin VB.TextBox Text1 
      Alignment       =   1  'Right Justify
      BackColor       =   &H80000006&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   24
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000FF00&
      Height          =   675
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   6
      Text            =   "000000"
      Top             =   120
      Width           =   1815
   End
   Begin VB.OptionButton Option2 
      Caption         =   "COM2"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   2040
      Width           =   855
   End
   Begin VB.OptionButton Option1 
      Caption         =   "COM1"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   1800
      Value           =   -1  'True
      Width           =   855
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Command3"
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   120
      Width           =   735
   End
   Begin VB.CommandButton Command2 
      Caption         =   "mS"
      Height          =   375
      Left            =   2760
      TabIndex        =   2
      Top             =   840
      Width           =   615
   End
   Begin VB.CommandButton Command1 
      Caption         =   "uS"
      Height          =   375
      Left            =   2760
      TabIndex        =   1
      Top             =   1320
      Width           =   615
   End
   Begin VB.Timer Timer1 
      Interval        =   50
      Left            =   2760
      Top             =   1920
   End
   Begin MSCommLib.MSComm Comm1 
      Left            =   2040
      Top             =   1800
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Label Label2 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   2040
      TabIndex        =   8
      Top             =   1080
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Hz"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   2040
      TabIndex        =   0
      Top             =   240
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Frequency counter 1MHz
'PIC16F628 transmits 20 bits binary in 3 bytes.
'
'This code is free to use
'for more info visit www.moty22.co.uk
Dim sec As Boolean

Private Sub Command1_Click()   'select range
sec = True
End Sub

Private Sub Command2_Click()   'select range
sec = False
End Sub
Private Sub Command3_Click()       'select COM port
If Command3.Caption = "START" Then
If Option1.Value = True Then
Comm1.CommPort = "1"
Else
Comm1.CommPort = "2"
End If
Comm1.PortOpen = True
Comm1.Settings = "1200,n,8,1"
Comm1.RTSEnable = True
Timer1.Enabled = True
Command3.Caption = "STOP"
Option1.Enabled = False
Option2.Enabled = False

Else
Option1.Enabled = True
Option2.Enabled = True
Comm1.PortOpen = False
Timer1.Enabled = False
Command3.Caption = "START"
Text1.Text = "000000"
Text2.Text = "000000"
End If
End Sub
Private Sub Form_Load()

Command3.Caption = "START"
End Sub

Private Sub Form_Unload(Cancel As Integer)
If Comm1.PortOpen = True Then     'port must be closed
Comm1.PortOpen = False
End If
End Sub

Private Sub Timer1_Timer()
Dim byte1, byte2, byte3 As Variant
Dim cnt1, cnt2, cnt3, freq As Long

If Comm1.InBufferCount > 2 Then
byte1 = Comm1.Input               'read byte 1
byte2 = Mid(byte1, 2, 1)       'read byte 2
cnt1 = Asc(byte1)                  'convert byte 1 to integer
cnt2 = Asc(byte2)
byte3 = Mid(byte1, 3, 1)   'read byte 3
cnt3 = Asc(byte3)                 'convert byte 1 to integer
freq = cnt2 * 255 + cnt1 + cnt3 * 65536  'sum of 3 bytes

If freq >= 999999 Or freq = 0 Then
Text2.Text = "HELLO"
Text1.Text = ""
Exit Sub
End If

Text1.Text = freq
If sec = True Then
Text2.Text = Format(1000000 / freq, "0.00000")  'calculate period
Label2.Caption = "uS"
Else
Text2.Text = Format(1000 / freq, "0.00000")
Label2.Caption = "mS"
End If
End If
End Sub
